/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dobavljac;

import artikli.Artikl;
import java.util.Queue;
import javax.annotation.Resource;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSContext;
import javax.jms.JMSException;
import javax.jms.JMSProducer;
import javax.jms.ObjectMessage;

/**
 *
 * @author tamarasekularac
 */
public class Main {
    @Resource(lookup = "jms/__defaultConnectionFactory")
    private static javax.jms.ConnectionFactory connectionFactory;
    
    @Resource(lookup = "mojRed")
    private static javax.jms.Queue queue;
 
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws JMSException {
        JMSContext context = connectionFactory.createContext();
        JMSProducer producer = context.createProducer();
        
        while(true){
            try {
                int sekunde = (int)(Math.random() * 11 + 10);
                int tip = (int)(Math.random() * Artikl.TipArtikla.values().length);
                int kol=(int)(Math.random() * 6+5);
                Artikl artikl=new Artikl(kol, Artikl.TipArtikla.values()[tip]);
                ObjectMessage objectMessage = context.createObjectMessage();
                objectMessage.setObject(artikl);
                producer.send((Destination) queue, objectMessage);

               

                System.out.println("Dobavljac: " + artikl.getTipString() + "x " + artikl.getKolicina());
                Thread.sleep(sekunde * 1000);
            } catch (InterruptedException ex) {
                
            } catch (JMSException ex) {
            }
        }
    }
    
}
