/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package prodavac;

import artikli.Artikl;
import java.util.Queue;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSConsumer;
import javax.jms.JMSContext;
import javax.jms.JMSException;
import javax.jms.JMSProducer;
import javax.jms.Message;
import javax.jms.ObjectMessage;
import javax.jms.TextMessage;

/**
 *
 * @author tamarasekularac
 */
public class Main {
 @Resource(lookup = "jms/__defaultConnectionFactory")
    private static javax.jms.ConnectionFactory connectionFactory;
    
    @Resource(lookup = "mojRed")
    private static javax.jms.Queue queue;
    
    private static int[] lager;
    
    public static void main(String[] args) {
        
        lager=new int[Artikl.TipArtikla.values().length];
        
        JMSContext context = connectionFactory.createContext();
        JMSConsumer consumer = context.createConsumer((Destination)queue);
        
        consumer.setMessageListener((Message message) -> {
            if(message instanceof ObjectMessage){
                try {
                    ObjectMessage objectMessage = (ObjectMessage) message;
                    Artikl nabavka = (Artikl) objectMessage.getObject();
                    Main.lager[nabavka.getTip().ordinal()]+=nabavka.getKolicina();
                    System.out.println("Dobavljac je doneo: " + nabavka.getTipString() + "x " + nabavka.getKolicina());
                } catch (JMSException ex) {
                } 
            }
        });
        JMSProducer producer = context.createProducer();
        
        while(true){
            int sekunde = (int)(Math.random() * 5 + 4);
            try{
            Thread.sleep(sekunde * 1000);
            }
            catch (InterruptedException ex){}
            int tip=(int)(Math.random()*Artikl.TipArtikla.values().length);
            Artikl artikl=new Artikl(1,Artikl.TipArtikla.values()[tip]);
            if(lager[tip]>0){
                lager[tip]--;
                System.out.println("Prodata: "+artikl.getTipString());
            }
            else
                System.out.println("Nema na lageru: "+artikl.getTipString());
            
        }
    }
    
}
