/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package artikli;

import java.io.Serializable;

/**
 *
 * @author tamarasekularac
 */
public class Artikl implements Serializable {
    private TipArtikla tip = TipArtikla.OLOVKA;
    private int kolicina;
    
    public enum TipArtikla{
        OLOVKA, SVESKA, KNJIGA; 
    }
    
    public Artikl(int kol, TipArtikla tip){
        kolicina=kol;
        this.tip = tip;
    }

    public TipArtikla getTip() {
        return tip;
    }
    public String getTipString() {
        if(tip==TipArtikla.OLOVKA)
            return "olovka";
        if(tip==TipArtikla.SVESKA)
            return "sveska";
        if(tip==TipArtikla.KNJIGA)
            return "knjiga";
        return "nesto";
    }    
    

    public void setTip(TipArtikla tip) {
        this.tip = tip;
    }

    public int getKolicina() {
        return kolicina;
    }

    public void setKolicina(int kolicina) {
        this.kolicina = kolicina;
    }
    
    
}
